diff --git a/rsvg-path.c b/rsvg-path.c
index 3ba5cb1..ee32ee6 100644
--- a/rsvg-path.c
+++ b/rsvg-path.c
@@ -409,148 +556,174 @@ rsvg_path_end_of_number (RSVGParsePathCtx * ctx, double val, int sign, int exp_s
 {
     val *= sign * pow (10, exp_sign * exp);
     if (ctx->rel) {
-      /* Handle relative coordinates. This switch statement attempts
-	 to determine _what_ the coords are relative to. This is
-	 underspecified in the 12 Apr working draft. */
-      switch (ctx->cmd) {
-      case 'l':
-      case 'm':
-      case 'c':
-      case 's':
-      case 'q':
-      case 't':
-#ifndef RSVGV_RELATIVE
-	/* rule: even-numbered params are x-relative, odd-numbered
-	   are y-relative */
-	if ((ctx->param & 1) == 0)
-	  val += ctx->cpx;
-	else if ((ctx->param & 1) == 1)
-	  val += ctx->cpy;
-	break;
-#else
-	/* rule: even-numbered params are x-relative, odd-numbered
-	   are y-relative */
-	if (ctx->param == 0 || (ctx->param % 2 == 0))
-	  val += ctx->cpx;
-	else
-	  val += ctx->cpy;
-	break;
-#endif
-      case 'a':
-	/* rule: sixth and seventh are x and y, rest are not
-	   relative */
-	if (ctx->param == 5)
-	  val += ctx->cpx;
-	else if (ctx->param == 6)
-	  val += ctx->cpy;
-	break;
-      case 'h':
-	/* rule: x-relative */
-	val += ctx->cpx;
-	break;
-      case 'v':
-	/* rule: y-relative */
-	val += ctx->cpy;
-	break;
-      }
+        /* Handle relative coordinates. This switch statement attempts
+           to determine _what_ the coords are relative to. This is
+           underspecified in the 12 Apr working draft. */
+        switch (ctx->cmd) {
+        case 'l':
+        case 'm':
+        case 'c':
+        case 's':
+        case 'q':
+        case 't':
+            /* rule: even-numbered params are x-relative, odd-numbered
+               are y-relative */
+            if ((ctx->param & 1) == 0)
+                val += ctx->cp.point.x;
+            else if ((ctx->param & 1) == 1)
+                val += ctx->cp.point.y;
+            break;
+        case 'a':
+            /* rule: sixth and seventh are x and y, rest are not
+               relative */
+            if (ctx->param == 5)
+                val += ctx->cp.point.x;
+            else if (ctx->param == 6)
+                val += ctx->cp.point.y;
+            break;
+        case 'h':
+            /* rule: x-relative */
+            val += ctx->cp.point.x;
+            break;
+        case 'v':
+            /* rule: y-relative */
+            val += ctx->cp.point.y;
+            break;
+        }
     }
     ctx->params[ctx->param++] = val;
     rsvg_parse_path_do_cmd (ctx, FALSE);    
 }
 
+#define RSVGN_IN_PREINTEGER  0
+#define RSVGN_IN_INTEGER     1
+#define RSVGN_IN_FRACTION    2
+#define RSVGN_IN_PREEXPONENT 3
+#define RSVGN_IN_EXPONENT    4
+
+#define RSVGN_GOT_SIGN          0x1
+#define RSVGN_GOT_EXPONENT_SIGN 0x2
+
+/* Returns the length of the number parsed, so it can be skipped
+ * in rsvg_parse_path_data. Calls rsvg_path_end_number to have the number
+ * processed in its command.
+ */
+static int
+rsvg_parse_number (RSVGParsePathCtx * ctx, const char *data)
+{
+    int length = 0;
+    int in = RSVGN_IN_PREINTEGER; /* Current location within the number */
+    int got = 0x0; /* [bitfield] Having 2 of each of these is an error */
+    gboolean end = FALSE; /* Set to true if the number should end after a char */
+    gboolean error = FALSE; /* Set to true if the number ended due to an error */
+
+    double value = 0.0;
+    double fraction = 1.0;
+    int sign = +1; /* Presume the INTEGER is positive if it has no sign */
+    int exponent = 0;
+    int exponent_sign = +1; /* Presume the EXPONENT is positive if it has no sign */
+
+    while (data[length] != '\0' && !end && !error) {
+        char c = data[length];
+        switch (in) {
+            case RSVGN_IN_PREINTEGER: /* No numbers yet, we're just starting out */
+                /* LEGAL: + - .->FRACTION DIGIT->INTEGER */
+                if (c == '+' || c == '-') {
+                    if (got & RSVGN_GOT_SIGN) {
+                        error = TRUE; /* Two signs: not allowed */
+                    } else {
+                        sign = c == '+' ? +1 : -1;
+                        got |= RSVGN_GOT_SIGN;
+                    }
+                } else if (c == '.') {
+                    in = RSVGN_IN_FRACTION;
+                } else if (c >= '0' && c <= '9') {
+                    value = c - '0';
+                    in = RSVGN_IN_INTEGER;
+                }
+                break;
+            case RSVGN_IN_INTEGER: /* Previous character(s) was/were digit(s) */
+                /* LEGAL: DIGIT .->FRACTION E->PREEXPONENT */
+                if (c >= '0' && c <= '9') {
+                    value = value * 10 + (c - '0');
+                }
+                else if (c == '.') {
+                    in = RSVGN_IN_FRACTION;
+                }
+                else if (c == 'e' || c == 'E') {
+                    in = RSVGN_IN_PREEXPONENT;
+                }
+                else {
+                    end = TRUE;
+                }
+                break;
+            case RSVGN_IN_FRACTION: /* Previously, digit(s) in the fractional part */
+                /* LEGAL: DIGIT E->PREEXPONENT */
+                if (c >= '0' && c <= '9') {
+                    fraction *= 0.1;
+                    value += fraction * (c - '0');
+                }
+                else if (c == 'e' || c == 'E') {
+                    in = RSVGN_IN_PREEXPONENT;
+                }
+                else {
+                    end = TRUE;
+                }
+                break;
+            case RSVGN_IN_PREEXPONENT: /* Right after E */
+                /* LEGAL: + - DIGIT->EXPONENT */
+                if (c == '+' || c == '-') {
+                    if (got & RSVGN_GOT_EXPONENT_SIGN) {
+                        error = TRUE; /* Two signs: not allowed */
+                    } else {
+                        exponent_sign = c == '+' ? +1 : -1;
+                        got |= RSVGN_GOT_EXPONENT_SIGN;
+                    }
+                } else if (c >= '0' && c <= '9') {
+                    exponent = c - '0';
+                    in = RSVGN_IN_EXPONENT;
+                }
+                break;
+            case RSVGN_IN_EXPONENT: /* After E and the sign, if applicable */
+                /* LEGAL: DIGIT */
+                if (c >= '0' && c <= '9') {
+                    exponent = exponent * 10 + (c - '0');
+                } else {
+                    end = TRUE;
+                }
+                break;
+        }
+        length++;
+    }
+
+    /* TODO? if (error) report_the_error_somehow(); */
+    rsvg_path_end_of_number(ctx, value, sign, exponent_sign, exponent);
+    return end /* && !error */ ? length - 1 : length;
+}
+
 static void
 rsvg_parse_path_data (RSVGParsePathCtx * ctx, const char *data)
 {
     int i = 0;
-    double val = 0;
     char c = 0;
-    gboolean in_num = FALSE;
-    gboolean in_frac = FALSE;
-    gboolean in_exp = FALSE;
-    gboolean exp_wait_sign = FALSE;
-    int sign = 0;
-    int exp = 0;
-    int exp_sign = 0;
-    double frac = 0.0;
-
-    in_num = FALSE;
-    for (i = 0;; i++) {
+
+    for (i = 0; data[i] != '\0'; i++) {
         c = data[i];
-        if (c >= '0' && c <= '9') {
+        if ((c >= '0' && c <= '9') || c == '+' || c == '-' || c == '.') {
             /* digit */
-            if (in_num) {
-                if (in_exp) {
-                    exp = (exp * 10) + c - '0';
-                    exp_wait_sign = FALSE;
-                } else if (in_frac)
-                    val += (frac *= 0.1) * (c - '0');
-                else
-                    val = (val * 10) + c - '0';
-            } else {
-                in_num = TRUE;
-                in_frac = FALSE;
-                in_exp = FALSE;
-                exp = 0;
-                exp_sign = 1;
-                exp_wait_sign = FALSE;
-                val = c - '0';
-                sign = 1;
-            }
-        } else if (c == '.') {
-	    if (in_frac) {
-	      rsvg_path_end_of_number(ctx, val, sign, exp_sign, exp);
-	      in_num = TRUE;
-	      in_frac = FALSE;
-	      in_exp = FALSE;
-	      exp = 0;
-	      exp_sign = 1;
-	      exp_wait_sign = FALSE;
-	      val = 0;
-	      sign = 1;
-	    }
-	    else if (!in_num) {
-                in_num = TRUE;
-                val = 0;
-            }
-            in_frac = TRUE;
-            frac = 1;
-        } else if ((c == 'E' || c == 'e') && in_num) {
-            in_exp = TRUE;
-            exp_wait_sign = TRUE;
-            exp = 0;
-            exp_sign = 1;
-        } else if ((c == '+' || c == '-') && in_exp) {
-            exp_sign = c == '+' ? 1 : -1;
-        } else if (in_num) {
-            /* end of number */
-	    rsvg_path_end_of_number(ctx, val, sign, exp_sign, exp);
-	    in_num = FALSE;
-        }
-
-        if (c == '\0')
-            break;
-        else if ((c == '+' || c == '-') && !exp_wait_sign) {
-            sign = c == '+' ? 1 : -1;
-            val = 0;
-            in_num = TRUE;
-            in_frac = FALSE;
-            in_exp = FALSE;
-            exp = 0;
-            exp_sign = 1;
-            exp_wait_sign = FALSE;
+            i += rsvg_parse_number(ctx, data + i) - 1;
         } else if (c == 'z' || c == 'Z') {
             if (ctx->param)
                 rsvg_parse_path_do_cmd (ctx, TRUE);
-            rsvg_bpath_def_closepath (ctx->bpath);
+            rsvg_path_builder_close_path (&ctx->builder);
 
-            ctx->cpx = ctx->rpx = ctx->bpath->bpath[ctx->bpath->n_bpath - 1].x3;
-            ctx->cpy = ctx->rpy = ctx->bpath->bpath[ctx->bpath->n_bpath - 1].y3;
-        } else if (c >= 'A' && c <= 'Z' && c != 'E') {
+            ctx->cp = ctx->rp = g_array_index (ctx->builder.path_data, cairo_path_data_t, ctx->builder.path_data->len - 1);
+        } else if (c >= 'A' && c < 'Z' && c != 'E') {
             if (ctx->param)
                 rsvg_parse_path_do_cmd (ctx, TRUE);
             ctx->cmd = c + 'a' - 'A';
             ctx->rel = FALSE;
-        } else if (c >= 'a' && c <= 'z' && c != 'e') {
+        } else if (c >= 'a' && c < 'z' && c != 'e') {
             if (ctx->param)
                 rsvg_parse_path_do_cmd (ctx, TRUE);
             ctx->cmd = c;
@@ -560,14 +733,17 @@ rsvg_parse_path_data (RSVGParsePathCtx * ctx, const char *data)
     }
 }
 
-RsvgBpathDef *
+cairo_path_t *
 rsvg_parse_path (const char *path_str)
 {
     RSVGParsePathCtx ctx;
 
-    ctx.bpath = rsvg_bpath_def_new ();
-    ctx.cpx = 0.0;
-    ctx.cpy = 0.0;
+    rsvg_path_builder_init (&ctx.builder, 32);
+
+    ctx.cp.point.x = 0.0;
+    ctx.cp.point.y = 0.0;
+    ctx.rp.point.x = 0.0;
+    ctx.rp.point.y = 0.0;
     ctx.cmd = 0;
     ctx.param = 0;
 
@@ -576,5 +752,15 @@ rsvg_parse_path (const char *path_str)
     if (ctx.param)
         rsvg_parse_path_do_cmd (&ctx, TRUE);
 
-    return ctx.bpath;
+    return rsvg_path_builder_finish (&ctx.builder);
+}
+
+void
+rsvg_cairo_path_destroy (cairo_path_t *path)
+{
+    if (path == NULL)
+        return;
+
+    g_free (path->data);
+    g_free (path);
 }
diff --git a/rsvg-path.h b/rsvg-path.h
index 7560107..4d151f0 100644
--- a/rsvg-path.h
+++ b/rsvg-path.h
@@ -1,4 +1,5 @@
-/* vim: set sw=4 sts=4: -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 4 -*- */
+/* -*- Mode: C; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
+/* vim: set sw=4 sts=4 ts=4 expandtab: */
 /*
    rsvg-path.h: Draw SVG paths
 
@@ -26,12 +27,53 @@
 #ifndef RSVG_PATH_H
 #define RSVG_PATH_H
 
-#include "rsvg-bpath-util.h"
+#include <glib.h>
+#include <cairo.h>
 
 G_BEGIN_DECLS 
 
-RsvgBpathDef *rsvg_parse_path (const char *path_str);
+typedef struct {
+    GArray *path_data;
+    int     last_move_to_index;
+} RsvgPathBuilder;
+
+G_GNUC_INTERNAL
+void rsvg_path_builder_init (RsvgPathBuilder *builder,
+                             int n_elements);
+G_GNUC_INTERNAL
+void rsvg_path_builder_move_to (RsvgPathBuilder *builder,
+                                double x,
+                                double y);
+G_GNUC_INTERNAL
+void rsvg_path_builder_line_to (RsvgPathBuilder *builder,
+                                double x,
+                                double y);
+G_GNUC_INTERNAL
+void rsvg_path_builder_curve_to (RsvgPathBuilder *builder,
+                                 double x1,
+                                 double y1,
+                                 double x2,
+                                 double y2,
+                                 double x3,
+                                 double y3);
+
+G_GNUC_INTERNAL
+void rsvg_path_builder_arc (RsvgPathBuilder *builder,
+                            double x1, double y1,
+                            double rx, double ry,
+                            double x_axis_rotation,
+                            gboolean large_arc_flag, gboolean sweep_flag,
+                            double x2, double y2);
+
+G_GNUC_INTERNAL
+void rsvg_path_builder_close_path (RsvgPathBuilder *builder);
+G_GNUC_INTERNAL
+cairo_path_t *rsvg_path_builder_finish (RsvgPathBuilder *builder);
+G_GNUC_INTERNAL
+cairo_path_t *rsvg_parse_path (const char *path_str);
+G_GNUC_INTERNAL
+void rsvg_cairo_path_destroy (cairo_path_t *path);
 
 G_END_DECLS
 
-#endif                          /* RSVG_PATH_H */
+#endif /* RSVG_PATH_H */
diff --git a/rsvg-private.h b/rsvg-private.h
index 93fd046..35b4607 100644
--- a/rsvg-private.h
+++ b/rsvg-private.h
@@ -1,4 +1,5 @@
-/* vim: set sw=4 sts=4: -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 4 -*- */
+/* -*- Mode: C; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
+/* vim: set sw=4 sts=4 ts=4 expandtab: */
 /*
    rsvg-private.h: Internals of RSVG
 
@@ -26,8 +27,9 @@
 #ifndef RSVG_PRIVATE_H
 #define RSVG_PRIVATE_H
 
+#include <cairo.h>
+
 #include "rsvg.h"
-#include "rsvg-bpath-util.h"
 
 #include <libxml/SAX.h>
 #include <libxml/xmlmemory.h>
@@ -40,18 +42,21 @@
 # include <float.h>
 #endif
 
+#if !(GLIB_CHECK_VERSION (2, 24, 0))
+#include <gsf/gsf-output.h>
+#endif
+
 G_BEGIN_DECLS 
 
 typedef struct RsvgSaxHandler RsvgSaxHandler;
 typedef struct RsvgDrawingCtx RsvgDrawingCtx;
 typedef struct RsvgRender RsvgRender;
-typedef struct _RsvgPropertyBag RsvgPropertyBag;
+typedef GHashTable RsvgPropertyBag;
 typedef struct _RsvgState RsvgState;
 typedef struct _RsvgDefs RsvgDefs;
 typedef struct _RsvgNode RsvgNode;
 typedef struct _RsvgFilter RsvgFilter;
 typedef struct _RsvgNodeChars RsvgNodeChars;
-typedef struct _RsvgIRect RsvgIRect;
 
 /* prepare for gettext */
 #ifndef _
@@ -114,8 +119,6 @@ typedef struct _RsvgIRect RsvgIRect;
  */
 #define RSVG_ONE_MINUS_EPSILON (1.0 - DBL_EPSILON)
 
-GType _rsvg_register_types (GTypeModule * module);
-
 struct RsvgSaxHandler {
     void (*free) (RsvgSaxHandler * self);
     void (*start_element) (RsvgSaxHandler * self, const char *name, RsvgPropertyBag * atts);
@@ -123,7 +126,17 @@ struct RsvgSaxHandler {
     void (*characters) (RsvgSaxHandler * self, const char *ch, int len);
 };
 
+typedef enum {
+    RSVG_LOAD_POLICY_STRICT
+} RsvgLoadPolicy;
+
+#define RSVG_LOAD_POLICY_DEFAULT (RSVG_LOAD_POLICY_STRICT)
+
 struct RsvgHandlePrivate {
+    RsvgHandleFlags flags;
+
+    RsvgLoadPolicy load_policy;
+
     gboolean is_disposed;
     gboolean is_closed;
 
@@ -152,6 +165,7 @@ struct RsvgHandlePrivate {
 
     xmlParserCtxtPtr ctxt;
     GError **error;
+    GCancellable *cancellable;
 
     double dpi_x;
     double dpi_y;
@@ -161,108 +175,164 @@ struct RsvgHandlePrivate {
     GString *metadata;
 
     gchar *base_uri;
+    GFile *base_gfile;
 
     gboolean finished;
 
-    gboolean first_write;
-    gboolean is_gzipped;
-    void *gzipped_data;         /* really a GsfOutput */
     gboolean in_loop;		/* see get_dimension() */
+
+    gboolean first_write;
+#if GLIB_CHECK_VERSION (2, 24, 0)
+    GInputStream *data_input_stream; /* for rsvg_handle_write of svgz data */
+#else
+    GsfOutput *gzipped_data;
+#endif
 };
 
 typedef struct {
+    cairo_rectangle_t rect;
     gboolean active;
-    double x, y, w, h;
 } RsvgViewBox;
 
 /*Contextual information for the drawing phase*/
 
 struct RsvgDrawingCtx {
     RsvgRender *render;
-    GSList *state;
+    RsvgState *state;
     GError **error;
     RsvgDefs *defs;
-    gchar *base_uri;
     PangoContext *pango_context;
     double dpi_x, dpi_y;
     RsvgViewBox vb;
     GSList *vb_stack;
     GSList *drawsub_stack;
-    GSList *ptrs;
+    GSList *acquired_nodes;
 };
 
 /*Abstract base class for context for our backends (one as yet)*/
 
+typedef enum {
+  RSVG_RENDER_TYPE_INVALID,
+
+  RSVG_RENDER_TYPE_BASE,
+
+  RSVG_RENDER_TYPE_CAIRO = 8,
+  RSVG_RENDER_TYPE_CAIRO_CLIP
+} RsvgRenderType;
+
 struct RsvgRender {
+    RsvgRenderType type;
+
     void (*free) (RsvgRender * self);
 
-    PangoContext    *(*create_pango_context)	(RsvgDrawingCtx * ctx);
-    void	     (*render_pango_layout)	(RsvgDrawingCtx * ctx, PangoLayout *layout, 
-						 double x, double y);
-    void	     (*render_path)		(RsvgDrawingCtx * ctx, const RsvgBpathDef * path);
-    void	     (*render_image)		(RsvgDrawingCtx * ctx, const GdkPixbuf * pixbuf,
-						 double x, double y, double w, double h);
-    void	     (*pop_discrete_layer)	(RsvgDrawingCtx * ctx);
-    void	     (*push_discrete_layer)	(RsvgDrawingCtx * ctx);
-    void	     (*add_clipping_rect)	(RsvgDrawingCtx * ctx, double x, double y, 
-						 double w, double h);
-    GdkPixbuf	    *(*get_image_of_node)	(RsvgDrawingCtx * ctx, RsvgNode * drawable, 
-						 double w, double h);
+    PangoContext    *(*create_pango_context)    (RsvgDrawingCtx * ctx);
+    void             (*render_pango_layout)	    (RsvgDrawingCtx * ctx, PangoLayout *layout,
+                                                 double x, double y);
+    void             (*render_path)             (RsvgDrawingCtx * ctx, const cairo_path_t *path);
+    void             (*render_surface)          (RsvgDrawingCtx * ctx, cairo_surface_t *surface,
+                                                 double x, double y, double w, double h);
+    void             (*pop_discrete_layer)      (RsvgDrawingCtx * ctx);
+    void             (*push_discrete_layer)     (RsvgDrawingCtx * ctx);
+    void             (*add_clipping_rect)       (RsvgDrawingCtx * ctx, double x, double y,
+                                                 double w, double h);
+    cairo_surface_t *(*get_surface_of_node)     (RsvgDrawingCtx * ctx, RsvgNode * drawable,
+                                                 double w, double h);
 };
 
+static inline RsvgRender *
+_rsvg_render_check_type (RsvgRender *render,
+                         RsvgRenderType type)
+{
+  g_assert ((render->type & type) == type);
+  return render;
+}
+
+#define _RSVG_RENDER_CIC(render, render_type, RenderCType) \
+  ((RenderCType*) _rsvg_render_check_type ((render), (render_type)))
 
 typedef struct {
     double length;
     char factor;
 } RsvgLength;
 
-struct _RsvgIRect {
-    int x0, y0, x1, y1;
-};
-
 typedef struct {
-    gdouble x, y, w, h;
+    cairo_rectangle_t rect;
+    cairo_matrix_t affine;
     gboolean virgin;
-    double affine[6];
 } RsvgBbox;
 
 typedef enum {
-    RSVG_SIZE_ZOOM,
-    RSVG_SIZE_WH,
-    RSVG_SIZE_WH_MAX,
-    RSVG_SIZE_ZOOM_MAX
-} RsvgSizeType;
-
-typedef enum {
     objectBoundingBox, userSpaceOnUse
 } RsvgCoordUnits;
 
-struct RsvgSizeCallbackData {
-    RsvgSizeType type;
-    double x_zoom;
-    double y_zoom;
-    gint width;
-    gint height;
-
-    gboolean keep_aspect_ratio;
-};
-
-void _rsvg_size_callback (int *width, int *height, gpointer data);
-
-struct _RsvgPropertyBag {
-    GHashTable *props;
-};
+typedef enum {
+    RSVG_NODE_TYPE_INVALID = 0,
+
+    RSVG_NODE_TYPE_CHARS,
+    RSVG_NODE_TYPE_CIRCLE,
+    RSVG_NODE_TYPE_CLIP_PATH,
+    RSVG_NODE_TYPE_COMPONENT_TRANFER_FUNCTION,
+    RSVG_NODE_TYPE_DEFS,
+    RSVG_NODE_TYPE_ELLIPSE,
+    RSVG_NODE_TYPE_FILTER,
+    RSVG_NODE_TYPE_GROUP,
+    RSVG_NODE_TYPE_IMAGE,
+    RSVG_NODE_TYPE_LIGHT_SOURCE,
+    RSVG_NODE_TYPE_LINE,
+    RSVG_NODE_TYPE_LINEAR_GRADIENT,
+    RSVG_NODE_TYPE_MARKER,
+    RSVG_NODE_TYPE_MASK,
+    RSVG_NODE_TYPE_PATH,
+    RSVG_NODE_TYPE_PATTERN,
+    RSVG_NODE_TYPE_POLYGON,
+    RSVG_NODE_TYPE_POLYLINE,
+    RSVG_NODE_TYPE_RADIAL_GRADIENT,
+    RSVG_NODE_TYPE_RECT,
+    RSVG_NODE_TYPE_STOP,
+    RSVG_NODE_TYPE_SVG,
+    RSVG_NODE_TYPE_SWITCH,
+    RSVG_NODE_TYPE_SYMBOL,
+    RSVG_NODE_TYPE_TEXT,
+    RSVG_NODE_TYPE_TREF,
+    RSVG_NODE_TYPE_TSPAN,
+    RSVG_NODE_TYPE_USE,
+
+    /* Filter primitives */
+    RSVG_NODE_TYPE_FILTER_PRIMITIVE = 64,
+    RSVG_NODE_TYPE_FILTER_PRIMITIVE_BLEND,
+    RSVG_NODE_TYPE_FILTER_PRIMITIVE_COLOR_MATRIX,
+    RSVG_NODE_TYPE_FILTER_PRIMITIVE_COMPONENT_TRANSFER,
+    RSVG_NODE_TYPE_FILTER_PRIMITIVE_COMPOSITE,
+    RSVG_NODE_TYPE_FILTER_PRIMITIVE_CONVOLVE_MATRIX,
+    RSVG_NODE_TYPE_FILTER_PRIMITIVE_DIFFUSE_LIGHTING,
+    RSVG_NODE_TYPE_FILTER_PRIMITIVE_DISPLACEMENT_MAP,
+    RSVG_NODE_TYPE_FILTER_PRIMITIVE_ERODE,
+    RSVG_NODE_TYPE_FILTER_PRIMITIVE_FLOOD,
+    RSVG_NODE_TYPE_FILTER_PRIMITIVE_GAUSSIAN_BLUR,
+    RSVG_NODE_TYPE_FILTER_PRIMITIVE_IMAGE,
+    RSVG_NODE_TYPE_FILTER_PRIMITIVE_MERGE,
+    RSVG_NODE_TYPE_FILTER_PRIMITIVE_MERGE_NODE,
+    RSVG_NODE_TYPE_FILTER_PRIMITIVE_OFFSET,
+    RSVG_NODE_TYPE_FILTER_PRIMITIVE_SPECULAR_LIGHTING,
+    RSVG_NODE_TYPE_FILTER_PRIMITIVE_TILE,
+    RSVG_NODE_TYPE_FILTER_PRIMITIVE_TURBULENCE,
+
+} RsvgNodeType;
 
 struct _RsvgNode {
     RsvgState *state;
     RsvgNode *parent;
-    GString *type;
     GPtrArray *children;
+    RsvgNodeType type;
+    const char *name; /* owned by the xmlContext, invalid after parsing! */
     void (*free) (RsvgNode * self);
     void (*draw) (RsvgNode * self, RsvgDrawingCtx * ctx, int dominate);
     void (*set_atts) (RsvgNode * self, RsvgHandle * ctx, RsvgPropertyBag *);
 };
 
+#define RSVG_NODE_TYPE(node)                ((node)->type)
+#define RSVG_NODE_IS_FILTER_PRIMITIVE(node) (RSVG_NODE_TYPE((node)) & RSVG_NODE_TYPE_FILTER_PRIMITIVE)
+
 struct _RsvgNodeChars {
     RsvgNode super;
     GString *contents;
@@ -270,112 +340,110 @@ struct _RsvgNodeChars {
 
 typedef void (*RsvgPropertyBagEnumFunc) (const char *key, const char *value, gpointer user_data);
 
-RsvgPropertyBag	    *rsvg_property_bag_new	(const char **atts);
-void		     rsvg_property_bag_free	(RsvgPropertyBag * bag);
-G_CONST_RETURN char *rsvg_property_bag_lookup	(RsvgPropertyBag * bag, const char *key);
-guint		     rsvg_property_bag_size	(RsvgPropertyBag * bag);
-void		     rsvg_property_bag_enumerate (RsvgPropertyBag * bag, RsvgPropertyBagEnumFunc func, 
-						  gpointer user_data);
-
+G_GNUC_INTERNAL
+RsvgPropertyBag	    *rsvg_property_bag_new       (const char **atts);
+G_GNUC_INTERNAL
+RsvgPropertyBag	    *rsvg_property_bag_dup       (RsvgPropertyBag * bag);
+G_GNUC_INTERNAL
+void                 rsvg_property_bag_free      (RsvgPropertyBag * bag);
+G_GNUC_INTERNAL
+const char          *rsvg_property_bag_lookup    (RsvgPropertyBag * bag, const char *key);
+G_GNUC_INTERNAL
+guint                rsvg_property_bag_size	     (RsvgPropertyBag * bag);
+G_GNUC_INTERNAL
+void                 rsvg_property_bag_enumerate (RsvgPropertyBag * bag, RsvgPropertyBagEnumFunc func,
+                                                  gpointer user_data);
+/* for some reason this one's public... */
 GdkPixbuf *rsvg_pixbuf_from_data_with_size_data (const guchar * buff,
                                                  size_t len,
-                                                 struct RsvgSizeCallbackData *data,
+                                                 gpointer data,
                                                  const char *base_uri, GError ** error);
-
+G_GNUC_INTERNAL
 gboolean     rsvg_eval_switch_attributes	(RsvgPropertyBag * atts, gboolean * p_has_cond);
-GdkPixbuf   *_rsvg_pixbuf_new_cleared		(GdkColorspace colorspace, gboolean has_alpha,
-						 int bits_per_sample, int width, int height);
-
-gchar	    *rsvg_get_base_uri_from_filename	(const gchar * file_name);
-GByteArray  *_rsvg_acquire_xlink_href_resource	(const char *href,
-						 const char *base_uri, GError ** err);
-
-void rsvg_pop_discrete_layer	(RsvgDrawingCtx * ctx);
-void rsvg_push_discrete_layer	(RsvgDrawingCtx * ctx);
-void rsvg_render_path		(RsvgDrawingCtx * ctx, const char *d);
-void rsvg_render_image		(RsvgDrawingCtx * ctx, GdkPixbuf * pb,
-				 double x, double y, double w, double h);
-void rsvg_render_free		(RsvgRender * render);
-void rsvg_add_clipping_rect	(RsvgDrawingCtx * ctx, double x, double y, double w, double h);
-GdkPixbuf *rsvg_get_image_of_node (RsvgDrawingCtx * ctx, RsvgNode * drawable, double w, double h);
-
-
-void _rsvg_affine_invert (double dst_affine[6], const double src_affine[6]);
-
-/* flip the matrix, FALSE, FALSE is a simple copy operation, and
-   TRUE, TRUE equals a rotation by 180 degrees */
-void _rsvg_affine_flip (double dst_affine[6], const double src_affine[6], int horz, int vert);
-
-void _rsvg_affine_multiply (double dst[6], const double src1[6], const double src2[6]);
-
-/* set up the identity matrix */
-void _rsvg_affine_identity (double dst[6]);
-
-/* set up a scaling matrix */
-void _rsvg_affine_scale (double dst[6], double sx, double sy);
-
-/* set up a rotation matrix; theta is given in degrees */
-void _rsvg_affine_rotate (double dst[6], double theta);
-
-/* set up a shearing matrix; theta is given in degrees */
-void _rsvg_affine_shear (double dst[6], double theta);
-
-/* set up a translation matrix */
-void _rsvg_affine_translate (double dst[6], double tx, double ty);
-
-
-/* find the affine's "expansion factor", i.e. the scale amount */
-double _rsvg_affine_expansion (const double src[6]);
-
-/* Determine whether the affine transformation is rectilinear,
-   i.e. whether a rectangle aligned to the grid is transformed into
-   another rectangle aligned to the grid. */
-int _rsvg_affine_rectilinear (const double src[6]);
-
-/* Determine whether two affine transformations are equal within grid allignment */
-int _rsvg_affine_equal (double matrix1[6], double matrix2[6]);
-
+G_GNUC_INTERNAL
+gchar       *rsvg_get_base_uri_from_filename    (const gchar * file_name);
+G_GNUC_INTERNAL
+void rsvg_pop_discrete_layer    (RsvgDrawingCtx * ctx);
+G_GNUC_INTERNAL
+void rsvg_push_discrete_layer   (RsvgDrawingCtx * ctx);
+G_GNUC_INTERNAL
+RsvgNode *rsvg_acquire_node     (RsvgDrawingCtx * ctx, const char *url);
+G_GNUC_INTERNAL
+void rsvg_release_node          (RsvgDrawingCtx * ctx, RsvgNode *node);
+G_GNUC_INTERNAL
+void rsvg_render_path           (RsvgDrawingCtx * ctx, const cairo_path_t *path);
+G_GNUC_INTERNAL
+void rsvg_render_surface        (RsvgDrawingCtx * ctx, cairo_surface_t *surface,
+                                 double x, double y, double w, double h);
+G_GNUC_INTERNAL
+void rsvg_render_free           (RsvgRender * render);
+G_GNUC_INTERNAL
+void rsvg_add_clipping_rect     (RsvgDrawingCtx * ctx, double x, double y, double w, double h);
+G_GNUC_INTERNAL
+cairo_surface_t *rsvg_cairo_surface_from_pixbuf (const GdkPixbuf *pixbuf);
+G_GNUC_INTERNAL
+GdkPixbuf *rsvg_cairo_surface_to_pixbuf (cairo_surface_t *surface);
+G_GNUC_INTERNAL
+cairo_surface_t *rsvg_get_surface_of_node (RsvgDrawingCtx * ctx, RsvgNode * drawable, double w, double h);
+G_GNUC_INTERNAL
 void rsvg_node_set_atts (RsvgNode * node, RsvgHandle * ctx, RsvgPropertyBag * atts);
-
+G_GNUC_INTERNAL
 void rsvg_drawing_ctx_free (RsvgDrawingCtx * handle);
-
-void rsvg_bbox_init	(RsvgBbox * self, double *affine);
-void rsvg_bbox_insert	(RsvgBbox * dst, RsvgBbox * src);
-void rsvg_bbox_clip	(RsvgBbox * dst, RsvgBbox * src);
-
-double _rsvg_css_normalize_length	(const RsvgLength * in, RsvgDrawingCtx * ctx, char dir);
-double _rsvg_css_hand_normalize_length	(const RsvgLength * in, gdouble pixels_per_inch,
-					 gdouble width_or_height, gdouble font_size);
-double _rsvg_css_hand_normalize_length_sub	(const RsvgLength * in, gdouble length,
-						 gdouble pixels_per_inch, gdouble width_or_height, 
-						 gdouble font_size);
-
+G_GNUC_INTERNAL
+void rsvg_bbox_init     (RsvgBbox * self, cairo_matrix_t *matrix);
+G_GNUC_INTERNAL
+void rsvg_bbox_insert   (RsvgBbox * dst, RsvgBbox * src);
+G_GNUC_INTERNAL
+void rsvg_bbox_clip     (RsvgBbox * dst, RsvgBbox * src);
+G_GNUC_INTERNAL
+double _rsvg_css_normalize_length       (const RsvgLength * in, RsvgDrawingCtx * ctx, char dir);
+G_GNUC_INTERNAL
+double _rsvg_css_hand_normalize_length  (const RsvgLength * in, gdouble pixels_per_inch,
+                                         gdouble width_or_height, gdouble font_size);
+double _rsvg_css_normalize_font_size    (RsvgState * state, RsvgDrawingCtx * ctx);
+G_GNUC_INTERNAL
+double _rsvg_css_accumulate_baseline_shift (RsvgState * state, RsvgDrawingCtx * ctx);
+G_GNUC_INTERNAL
 RsvgLength _rsvg_css_parse_length (const char *str);
-
+G_GNUC_INTERNAL
 void _rsvg_push_view_box    (RsvgDrawingCtx * ctx, double w, double h);
+G_GNUC_INTERNAL
 void _rsvg_pop_view_box	    (RsvgDrawingCtx * ctx);
-
+G_GNUC_INTERNAL
 void rsvg_SAX_handler_struct_init (void);
-
+G_GNUC_INTERNAL
 char *rsvg_get_url_string (const char *str);
-
+G_GNUC_INTERNAL
 void rsvg_return_if_fail_warning (const char *pretty_function,
                                   const char *expression, GError ** error);
 
-#define rsvg_return_if_fail(expr, error)		G_STMT_START{			\
-     if G_LIKELY(expr) { } else       					\
-       {								\
-	 rsvg_return_if_fail_warning (G_STRFUNC,			\
-		                   #expr, error);			\
-	 return;							\
+G_GNUC_INTERNAL
+char *_rsvg_handle_acquire_data (RsvgHandle *handle,
+                                 const char *uri,
+                                 char **content_type,
+                                 gsize *len,
+                                 GError **error);
+G_GNUC_INTERNAL
+GInputStream *_rsvg_handle_acquire_stream (RsvgHandle *handle,
+                                           const char *uri,
+                                           char **content_type,
+                                           GError **error);
+
+
+#define rsvg_return_if_fail(expr, error)    G_STMT_START{			\
+     if G_LIKELY(expr) { } else                                     \
+       {                                                            \
+           rsvg_return_if_fail_warning (G_STRFUNC,                  \
+                                        #expr, error);              \
+           return;                                                  \
        };				}G_STMT_END
 
-#define rsvg_return_val_if_fail(expr,val,error)	G_STMT_START{			\
-     if G_LIKELY(expr) { } else						\
-       {								\
-	 rsvg_return_if_fail_warning (G_STRFUNC,	    		\
-		                   #expr, error);			\
-	 return (val);							\
+#define rsvg_return_val_if_fail(expr,val,error)	G_STMT_START{       \
+     if G_LIKELY(expr) { } else                                     \
+       {                                                            \
+           rsvg_return_if_fail_warning (G_STRFUNC,                  \
+                                        #expr, error);              \
+           return (val);                                            \
        };				}G_STMT_END
 
 G_END_DECLS
